]> git.street.me.uk Git - andy/dehydrated.git/blob - test.sh
removed TODO mark from help text on renew of changed domains
[andy/dehydrated.git] / test.sh
1 #!/bin/bash
2
3 # Fail early
4 set -eu -o pipefail
5
6 # Check if running in CI environment
7 if [[ ! "${CI:-false}" == "true" ]]; then
8   echo "ERROR: Not running in CI environment!"
9   exit 1
10 fi
11
12 _TEST() {
13   echo
14   echo "${1} "
15 }
16 _SUBTEST() {
17   echo -n " + ${1} "
18 }
19 _PASS() {
20   echo -e "[\u001B[32mPASS\u001B[0m]"
21 }
22 _FAIL() {
23   echo -e "[\u001B[31mFAIL\u001B[0m]"
24   echo
25   echo "Problem: ${@}"
26   echo
27   echo "STDOUT:"
28   cat tmplog
29   echo
30   echo "STDERR:"
31   cat errorlog
32   exit 1
33 }
34 _CHECK_FILE() {
35   _SUBTEST "Checking if file '${1}' exists..."
36   if [[ -e "${1}" ]]; then
37     _PASS
38   else
39     _FAIL "Missing file: ${1}"
40   fi
41 }
42 _CHECK_LOG() {
43   _SUBTEST "Checking if log contains '${1}'..."
44   if grep -- "${1}" tmplog > /dev/null; then
45     _PASS
46   else
47     _FAIL "Missing in log: ${1}"
48   fi
49 }
50 _CHECK_NOT_LOG() {
51   _SUBTEST "Checking if log doesn't contain '${1}'..."
52   if grep -- "${1}" tmplog > /dev/null; then
53     _FAIL "Found in log: ${1}"
54   else
55     _PASS
56   fi
57 }
58 _CHECK_ERRORLOG() {
59   _SUBTEST "Checking if errorlog is empty..."
60   if [[ -z "$(cat errorlog)" ]]; then
61     _PASS
62   else
63     _FAIL "Non-empty errorlog"
64   fi
65 }
66
67 # If not found (should be cached in travis) download ngrok
68 if [[ ! -e "ngrok/ngrok" ]]; then
69   (
70     mkdir -p ngrok
71     cd ngrog
72     wget https://dl.ngrok.com/ngrok_2.0.19_linux_amd64.zip -O ngrok.zip
73     unzip ngrok.zip ngrok
74     chmod +x ngrok
75   )
76 fi
77
78 # Run ngrok and grab temporary url from logfile
79 ngrok/ngrok http 8080 --log stdout --log-format logfmt --log-level debug > tmp.log &
80 sleep 2
81 TMP_URL="$(grep -Eo "Hostname:[a-z0-9]+.ngrok.io" tmp.log | head -1 | cut -d':' -f2)"
82 if [[ -z "${TMP_URL}" ]]; then
83   echo "Couldn't get an url from ngrok, not a letsencrypt.sh bug, tests can't continue."
84   exit 1
85 fi
86
87 # Run python webserver in .acme-challenges directory to serve challenge responses
88 mkdir -p .acme-challenges/.well-known/acme-challenge
89 (
90   cd .acme-challenges
91   python -m SimpleHTTPServer 8080 > /dev/null 2> /dev/null
92 ) &
93
94 # Generate config and create empty domains.txt
95 echo 'CA="https://acme-staging.api.letsencrypt.org/directory"' > config.sh
96 echo 'WELLKNOWN=".acme-challenges/.well-known/acme-challenge"' >> config.sh
97 touch domains.txt
98
99 # Check if help command is working
100 _TEST "Checking if help command is working..."
101 ./letsencrypt.sh --help > tmplog 2> errorlog || _FAIL "Script execution failed"
102 _CHECK_LOG "Default command: help"
103 _CHECK_LOG "--help (-h)"
104 _CHECK_LOG "--domain (-d) domain.tld"
105 _CHECK_ERRORLOG
106
107 # Run in cron mode with empty domains.txt (should only generate private key and exit)
108 _TEST "First run in cron mode, checking if private key is generated and registered"
109 ./letsencrypt.sh --cron > tmplog 2> errorlog || _FAIL "Script execution failed"
110 _CHECK_LOG "Registering account key"
111 _CHECK_FILE "private_key.pem"
112 _CHECK_ERRORLOG
113
114 # Temporarily move config out of the way and try signing certificate by using temporary config location
115 _TEST "Try signing using temporary config location and with domain as command line parameter"
116 mv config.sh tmp_config.sh
117 ./letsencrypt.sh --domain "${TMP_URL}" -f tmp_config.sh > tmplog 2> errorlog || _FAIL "Script execution failed"
118 _CHECK_NOT_LOG "Checking domain name(s) of existing cert"
119 _CHECK_LOG "Generating private key"
120 _CHECK_LOG "Requesting challenge for ${TMP_URL}"
121 _CHECK_LOG "Challenge is valid!"
122 _CHECK_LOG "Creating fullchain.pem"
123 _CHECK_LOG "Done!"
124 _CHECK_ERRORLOG
125 mv tmp_config.sh config.sh
126
127 # Move private key and add new location to config
128 mv private_key.pem account_key.pem
129 echo 'PRIVATE_KEY="./account_key.pem"' >> config.sh
130
131 # Add domain to domains.txt and run in cron mode again (should find a non-expiring certificate and do nothing)
132 _TEST "Run in cron mode again, this time with domain in domains.txt, should find non-expiring certificate"
133 echo "${TMP_URL}" >> domains.txt
134 ./letsencrypt.sh --cron > tmplog 2> errorlog || _FAIL "Script execution failed"
135 _CHECK_LOG "Checking domain name(s) of existing cert... unchanged."
136 _CHECK_LOG "Skipping!"
137 _CHECK_ERRORLOG
138
139 # Run in cron mode one last time, with domain in domains.txt and force-resign (should find certificate, resign anyway, and not generate private key)
140 _TEST "Run in cron mode one last time, with domain in domains.txt and force-resign"
141 echo "${TMP_URL}" >> domains.txt
142 ./letsencrypt.sh --cron --force > tmplog 2> errorlog || _FAIL "Script execution failed"
143 _CHECK_LOG "Checking domain name(s) of existing cert... unchanged."
144 _CHECK_LOG "Ignoring because renew was forced!"
145 _CHECK_NOT_LOG "Generating private key"
146 _CHECK_LOG "Requesting challenge for ${TMP_URL}"
147 _CHECK_LOG "Challenge is valid!"
148 _CHECK_LOG "Creating fullchain.pem"
149 _CHECK_LOG "Done!"
150 _CHECK_ERRORLOG
151
152 # Delete account key (not needed anymore)
153 rm account_key.pem
154
155 # Check if certificate is valid in various ways
156 _TEST "Verifying certificate..."
157 _SUBTEST "Verifying certificate on its own..."
158 openssl x509 -in "certs/${TMP_URL}/cert.pem" -noout -text > tmplog 2> errorlog && _PASS || _FAIL
159 _CHECK_LOG "CN=${TMP_URL}"
160 _SUBTEST "Verifying file with full chain..."
161 openssl x509 -in "certs/${TMP_URL}/fullchain.pem" -noout -text > /dev/null 2>> errorlog && _PASS || _FAIL
162 _SUBTEST "Verifying certificate against CA certificate..."
163 (openssl verify -verbose -CAfile "certs/${TMP_URL}/fullchain.pem" -purpose sslserver "certs/${TMP_URL}/fullchain.pem" 2>&1 || true) | (grep -v ': OK$' || true) >> errorlog 2>> errorlog && _PASS || _FAIL
164 _CHECK_ERRORLOG
165
166 # Revoke certificate using certificate key
167 _TEST "Revoking certificate..."
168 ./letsencrypt.sh --revoke "certs/${TMP_URL}/cert.pem" --privkey "certs/${TMP_URL}/privkey.pem" > tmplog 2> errorlog || _FAIL "Script execution failed"
169 _CHECK_LOG "Revoking certs/${TMP_URL}/cert.pem"
170 _CHECK_LOG "SUCCESS"
171 _CHECK_FILE "certs/${TMP_URL}/cert.pem-revoked"
172 _CHECK_ERRORLOG
173
174 # All done
175 exit 0